`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/04/09 23:12:53
// Design Name: 
// Module Name: BCD_down_cnt_2digit
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module BCD_down_cnt_2digit(
    input clk,
    input rst_n,
    input cnt_en,
    output reg [3:0]value0,
    output reg [3:0]value1
    );
    reg [3:0]cnt_tmp1, cnt_tmp2, cnt_tmp3, cnt_tmp4;

always@*
    if(value0 == 0 && cnt_en)
        begin
            cnt_tmp1 = 4'd9;
            cnt_tmp2 = value1 - 4'd1;
        end
    else
        begin
            cnt_tmp1 = value0 - cnt_en;
            cnt_tmp2 = value1;
        end
        
always@*
    if(value0 == 0 && value1 == 0)
        begin
            cnt_tmp3 = 4'd0;
            cnt_tmp4 = 4'd0;
        end
    else
        begin
            cnt_tmp3 = cnt_tmp2;
            cnt_tmp4 = cnt_tmp1;
        end
        
always@(posedge clk or negedge rst_n)
    if(~rst_n)
        begin
            value0 <= 4'd0;
            value1 <= 4'd3;
        end
    else
        begin
            value0 <= cnt_tmp4;
            value1 <= cnt_tmp3;
        end
        
endmodule
